'use strict';

var chunkTNILINST_cjs = require('./chunk-TNILINST.cjs');
var chunkD63P5O4Q_cjs = require('./chunk-D63P5O4Q.cjs');

// src/storage/base.ts
var MastraStorage = class extends chunkD63P5O4Q_cjs.MastraBase {
  /** @deprecated import from { TABLE_WORKFLOW_SNAPSHOT } '@mastra/core/storage' instead */
  static TABLE_WORKFLOW_SNAPSHOT = chunkTNILINST_cjs.TABLE_WORKFLOW_SNAPSHOT;
  /** @deprecated import from { TABLE_EVALS } '@mastra/core/storage' instead */
  static TABLE_EVALS = chunkTNILINST_cjs.TABLE_EVALS;
  /** @deprecated import from { TABLE_MESSAGES } '@mastra/core/storage' instead */
  static TABLE_MESSAGES = chunkTNILINST_cjs.TABLE_MESSAGES;
  /** @deprecated import from { TABLE_THREADS } '@mastra/core/storage' instead */
  static TABLE_THREADS = chunkTNILINST_cjs.TABLE_THREADS;
  /** @deprecated import { TABLE_TRACES } from '@mastra/core/storage' instead */
  static TABLE_TRACES = chunkTNILINST_cjs.TABLE_TRACES;
  hasInitialized = null;
  shouldCacheInit = true;
  constructor({ name }) {
    super({
      component: "STORAGE",
      name
    });
  }
  async __batchInsert({
    tableName,
    records
  }) {
    await this.init();
    return this.batchInsert({ tableName, records });
  }
  async __getThreadById({ threadId }) {
    await this.init();
    return this.getThreadById({ threadId });
  }
  async __getThreadsByResourceId({ resourceId }) {
    await this.init();
    return this.getThreadsByResourceId({ resourceId });
  }
  async __saveThread({ thread }) {
    await this.init();
    return this.saveThread({ thread });
  }
  async __updateThread({
    id,
    title,
    metadata
  }) {
    await this.init();
    return this.updateThread({ id, title, metadata });
  }
  async __deleteThread({ threadId }) {
    await this.init();
    return this.deleteThread({ threadId });
  }
  async __getMessages({ threadId, selectBy, threadConfig }) {
    await this.init();
    return this.getMessages({ threadId, selectBy, threadConfig });
  }
  async __saveMessages({ messages }) {
    await this.init();
    return this.saveMessages({ messages });
  }
  async __getTraces({
    scope,
    page,
    perPage,
    attributes,
    filters
  }) {
    await this.init();
    return this.getTraces({ scope, page, perPage, attributes, filters });
  }
  async init() {
    if (this.shouldCacheInit && await this.hasInitialized) {
      return;
    }
    this.hasInitialized = Promise.all([
      this.createTable({
        tableName: chunkTNILINST_cjs.TABLE_WORKFLOW_SNAPSHOT,
        schema: chunkTNILINST_cjs.TABLE_SCHEMAS[chunkTNILINST_cjs.TABLE_WORKFLOW_SNAPSHOT]
      }),
      this.createTable({
        tableName: chunkTNILINST_cjs.TABLE_EVALS,
        schema: chunkTNILINST_cjs.TABLE_SCHEMAS[chunkTNILINST_cjs.TABLE_EVALS]
      }),
      this.createTable({
        tableName: chunkTNILINST_cjs.TABLE_THREADS,
        schema: chunkTNILINST_cjs.TABLE_SCHEMAS[chunkTNILINST_cjs.TABLE_THREADS]
      }),
      this.createTable({
        tableName: chunkTNILINST_cjs.TABLE_MESSAGES,
        schema: chunkTNILINST_cjs.TABLE_SCHEMAS[chunkTNILINST_cjs.TABLE_MESSAGES]
      }),
      this.createTable({
        tableName: chunkTNILINST_cjs.TABLE_TRACES,
        schema: chunkTNILINST_cjs.TABLE_SCHEMAS[chunkTNILINST_cjs.TABLE_TRACES]
      })
    ]).then(() => true);
    await this.hasInitialized;
  }
  async persistWorkflowSnapshot({
    workflowName,
    runId,
    snapshot
  }) {
    await this.init();
    const data = {
      workflow_name: workflowName,
      run_id: runId,
      snapshot,
      createdAt: /* @__PURE__ */ new Date(),
      updatedAt: /* @__PURE__ */ new Date()
    };
    this.logger.debug("Persisting workflow snapshot", { workflowName, runId, data });
    await this.insert({
      tableName: chunkTNILINST_cjs.TABLE_WORKFLOW_SNAPSHOT,
      record: data
    });
  }
  async loadWorkflowSnapshot({
    workflowName,
    runId
  }) {
    if (!this.hasInitialized) {
      await this.init();
    }
    this.logger.debug("Loading workflow snapshot", { workflowName, runId });
    const d = await this.load({
      tableName: chunkTNILINST_cjs.TABLE_WORKFLOW_SNAPSHOT,
      keys: { workflow_name: workflowName, run_id: runId }
    });
    return d ? d.snapshot : null;
  }
  async __getEvalsByAgentName(agentName, type) {
    await this.init();
    return this.getEvalsByAgentName(agentName, type);
  }
  async __getWorkflowRuns(args) {
    if (!this.hasInitialized) {
      await this.init();
    }
    return this.getWorkflowRuns(args);
  }
};

exports.MastraStorage = MastraStorage;
